import sys
import re
import numpy as np
from genKer import rhsinfo, genrk3, genrk3update, genFilter, genBC, append_Rhs, genbcsrc
import os 

wp = 'float64'
  
from  rhs_NS3D import *

# Set install path (needed by genKer)
instpath = os.environ['INSTALLPATH']
incPATH  = instpath+'/src_for/includes/gen/'

def main():
      
      from genKer import rhs_info    
      rhs = rhs_info()

# Generate LHS:
      genrk3(len(varsolved)      ,rhs=rhs) 
      genrk3update(len(varsolved),rhs=rhs)

# Generate RHS:
      Save_eqns = {}
      Save_eqns = {'Src_conv':Src_conv.copy(),'Src_dif': Src_dif.copy()}
      append_Rhs(Src_conv  ,11, 10,rhsname,locname_conv,update=False,rhs=rhs)                           
      append_Rhs(Src_dif   ,5 ,4 ,rhsname,locname_dif ,update=True ,rhs=rhs)
      
# Generate Filters (if required):      
      genFilter(11,10, len(varsolved),rhs=rhs)

# Generate BCs:
      genbcsrc(len(varsolved),rhs=rhs)
      genBC(Save_eqns['Src_conv'] ,11,10,rhsname , locname_conv, update=False,rhs=rhs)
      genBC(Save_eqns['Src_dif'] ,5,4   ,rhsname , locname_dif , update=True ,rhs=rhs)
      genBC(Src_phybc_conv ,5,4,rhsname , locname_bc, setbc=[True,{'wall':{'dir':['i1'],'type':[0,'q']}}], update=False,rhs=rhs)


# Extract RHS info:
      rhsinfo(rhs)

if __name__ == '__main__':
    main()
