import sys
import re
import numpy as np
from genKer import loop, globvar, rhsinfo, gendtype, genrk3, genrk3update, genFilter, genP2C, genBC, append_Rhs, geninit, genbcsrc
import os 

wp = 'float64'
  
# from  rhs_debug import *
from  rhs_NS3D import *
# from  rhs_NS3D_skewsym import *
# from  rhs_NS3D_vdw import *
# from  rhs_NS3D_skewsym_vdw import *

# include PATH
instpath = os.environ['INSTALLPATH']
incPATH  = instpath+'/src_for/includes/gen/'

outputconv     = open(incPATH+'includeRHS_conv.f90','w')
outputconvloc  = open(incPATH+'includeRHS_conv_loc.f90','w')


outputdif   = open(incPATH+'includeRHS_dif.f90','w')
outputsrc   = open(incPATH+'includeRHS_src.f90','w')


localvar    = open(incPATH+'includeRHS_locVar.f90','w')
globalvarRhs= open(incPATH+'includeRHS_globVar.f90','w')  
globalvarRk3= open(incPATH+'includeRHS_globVar_rk3.f90','w')
globalvarFlt= open(incPATH+'includeRHS_globVar_filter.f90','w')

rk3         = open(incPATH+'includeRK3.f90','w')
updaterk3   = open(incPATH+'includeRK3update.f90','w')
cns         = open(incPATH+'primitive_to_conservative.f90','w')
init        = open(incPATH+'init_numa.f90','w')

lbeg     = open(incPATH+'LOOP_BEGIN','w')
lend     = open(incPATH+'LOOP_END','w')

bc       = open(incPATH+'includeBC.f90','w')

#genBC('kmax',test,13,4,rhsname,vnamesrc,bc,localvar,update=False)

#sys.exit()
def main():

      gendtype(wp)
      
      from genKer import rhs_info    
      rhs = rhs_info()

      # append_Rhs(Flxconv,11,10,rhsname,vname,outputconv,localvar,update=False, rhs=rhs)
      # append_Rhs(Flxdif ,5 , 4,rhsname,vname,outputconv ,localvar,update=True, rhs=rhs)

      # append_Rhs(Flxconv_loc,11,10,rhsname,vname_loc,outputconvloc,localvar,   update=True,rhs=rhs)

      ## Div + Lap
      # append_Rhs(Flxconv,stencil,order,rhsname,vname,outputconv,localvar,    rhs=rhs)
      # append_Rhs(SLaplace,5,4,rhsname,vnamesrc,outputsrc,localvar,update=True,rhs=rhs)

      # # # skew + div  
      # append_Rhs(Skew,stencil,order,rhsname,vnamesrc_skew,outputconv,localvar,   update=False,rhs=rhs)    
      # append_Rhs(Flxdif ,5,4,rhsname,vname,outputdif ,localvar,update=True,rhs=rhs)      

      # # # skew + laplace 
      # append_Rhs(divF,3,2,rhsname,vnamesrc_div,outputconv,localvar,   update=False,rhs=rhs)
      # append_Rhs(diff,3,2,rhsname,vnamesrc_dif,outputsrc,localvar,update=False,rhs=rhs)

      append_Rhs(Src_conv,11,10,rhsname,locname_conv,outputconv,localvar,   update=False,rhs=rhs)
      append_Rhs(Src_dif,5,4   ,rhsname,locname_dif  ,outputsrc,localvar,   update=True ,rhs=rhs)

      # append_Rhs(SLaplace,5,4 ,rhsname,locname_dif  ,outputsrc,localvar,   update=True ,rhs=rhs)

      # append_Rhs(Skew,11,10,rhsname,vnamesrc_skew,outputconv,localvar,   update=False,rhs=rhs)
      # append_Rhs(SLaplace,5,4,rhsname,vnamesrc,outputsrc,localvar,       update=True ,rhs=rhs)
      
      
      loop(lbeg,lend)
      
      globvar(globalvarRhs, 'rhs')  
      globvar(globalvarRk3, 'rk3')
      globvar(globalvarFlt, 'flt')
      
      genFilter(incPATH, 11, 10, len(varname), rhs=rhs)
      genbcsrc(incPATH,len(varname),  rhs=rhs)

      genrk3(rk3,len(varname), rhs=rhs) 

      genrk3update(updaterk3,len(varname), rhs=rhs)
      genP2C(updaterk3,'primitive',rhs=rhs)

      genP2C(cns,'conservative',rhs=rhs)
      geninit(init,len(varname),rhs=rhs)
      rhsinfo(rhs)

if __name__ == '__main__':
    main()
