import sys
import re
import numpy as np
from genKer import div, loop, globvar, rhsinfo, gendtype, genrk3, genrk3update, genFilter, genP2C, genBC, src, geninit, genbcsrc
import os 
#FD scheme : [currentely availlabale : (13,4) and (3,2), see genKer.py]

wp = 'float64'

# dirichletBC = {'u' : 1,
#                'T' : 2}
  
# from  rhs_NS3D_skewsym import *
from  rhs_NS3D import *
# from  rhs_NS3D_vdw import *
# from  rhs_NS3D_skewsym_vdw import *

##  BC wall Preliminary tests
Wall = {'imin' : None,
        'imax' : None,
        'jmin' : None,
        'jmax' : None,
        'kmin' : None,
        'kmax' : None,
        } 



# include PATH
instpath = os.environ['INSTALLPATH']
incPATH  = instpath+'/src_for/includes/gen/'

outputconv     = open(incPATH+'includeRHS_conv.f90','w')
outputconvloc  = open(incPATH+'includeRHS_conv_loc.f90','w')


outputdif   = open(incPATH+'includeRHS_dif.f90','w')
outputsrc   = open(incPATH+'includeRHS_src.f90','w')


localvar    = open(incPATH+'includeRHS_locVar.f90','w')
globalvarRhs= open(incPATH+'includeRHS_globVar.f90','w')  
globalvarRk3= open(incPATH+'includeRHS_globVar_rk3.f90','w')
globalvarFlt= open(incPATH+'includeRHS_globVar_filter.f90','w')

rk3         = open(incPATH+'includeRK3.f90','w')
updaterk3   = open(incPATH+'includeRK3update.f90','w')
cns         = open(incPATH+'primitive_to_conservative.f90','w')
init        = open(incPATH+'init_numa.f90','w')

lbeg     = open(incPATH+'LOOP_BEGIN','w')
lend     = open(incPATH+'LOOP_END','w')

bc       = open(incPATH+'includeBC.f90','w')

#genBC('kmax',test,13,4,rhsname,vnamesrc,bc,localvar,update=False)

#sys.exit()
def main():

      gendtype(wp)
      
      # div(Flx,stencil,order,rhsname,vname,outputconv,localvar)
      from genKer import rhs_info    
      rhs = rhs_info()

      div(Flxconv,11,10,rhsname,vname,outputconv,localvar,update=False, rhs=rhs)
      div(Flxdif ,5 , 4,rhsname,vname,outputconv ,localvar,update=True, rhs=rhs)
      # src(Flxconv_loc,11,10,rhsname,vname_loc,outputconvloc,localvar,   update=True,rhs=rhs)

      ## Div + Lap
      # div(Flxconv,stencil,order,rhsname,vname,outputconv,localvar,    rhs=rhs)
      # src(SLaplace,5,4,rhsname,vnamesrc,outputsrc,localvar,update=True,rhs=rhs)

      # # # skew + div  
      # src(Skew,stencil,order,rhsname,vnamesrc_skew,outputconv,localvar,   update=False,rhs=rhs)    
      # div(Flxdif ,5,4,rhsname,vname,outputdif ,localvar,update=True,rhs=rhs)      

      # # # skew + laplace 
      # src(Skew,stencil,order,rhsname,vnamesrc_skew,outputconv,localvar,   update=False,rhs=rhs)
      # src(SLaplace,5,4,rhsname,vnamesrc,outputsrc,localvar,update=True,rhs=rhs)
      
      
      loop(lbeg,lend)
      
      globvar(globalvarRhs, 'rhs')  
      globvar(globalvarRk3, 'rk3')
      globvar(globalvarFlt, 'flt')
      
      genFilter(incPATH,len(vname), 11, 10, rhs=rhs)
      genbcsrc(incPATH,len(vname),  rhs=rhs)

      genrk3(rk3,len(vname), rhs=rhs) 

      genrk3update(updaterk3,len(vname), rhs=rhs)
      genP2C(updaterk3,'primitive',rhs=rhs)

      genP2C(cns,'conservative',rhs=rhs)
      geninit(init,len(vname),rhs=rhs)
      rhsinfo(rhs)

if __name__ == '__main__':
    main()
